Option Strict Off
Imports System
Imports NXOpen
Imports NXOpen.UI
Imports NXOpen.UF

Module Move_Selected_Objects_to_Layer

    Sub Main()

        Dim theSession As Session = Session.GetSession()
        Dim theUI As UI = UI.GetUI()
        Dim lw As ListingWindow = theSession.ListingWindow()
        Dim obj As NXObject = Nothing
        Dim wp As Part = Session.GetSession.Parts.Work

        ' Fullpath ist bereits ein String, braucht daher kein .tostring mehr.
        Dim ai As String = wp.FullPath

        ' Muss nicht bei jedem Schleifendurchlauf gemacht werden.
        lw.Open()

        While select_object(obj) = Selection.Response.Ok

            ' Hier wird der vollständige Name des workpart ausgegeben.
            ' Das hat mit der Selektion aber nichts zu tun.

            'lw.WriteLine("ai")
            MsgBox(ai)

            ' Selektiertes Objekt ausgeben (Objekttyp und Tag)
            lw.WriteLine(obj.ToString)

            ' Objekt auf Layer 55 legen
            CType(obj, DisplayableObject).Layer = 55

        End While

    End Sub

    'Selection für Flächen, Solids und Circles

    Function select_object(ByRef obj As NXObject)

        Dim ui As UI = ui.GetUI()
        Dim message As String = "Select an object"
        Dim title As String = "Selection"
        Dim selectionMask(1) As Selection.MaskTriple
        ' Solid- und Sheetbodies
        With selectionMask(0)
            .Type = UFConstants.UF_solid_type
            .Subtype = 0
            .SolidBodySubtype = 0
        End With
        ' Kurven vom Typ Circle
        With selectionMask(1)
            .Type = UFConstants.UF_circle_type
            .Subtype = 0
            .SolidBodySubtype = 0
        End With

        Dim cursor As Point3d = Nothing

        Dim resp As Selection.Response = _
            ui.SelectionManager.SelectObject(message, title, _
                Selection.SelectionScope.WorkPart, _
                Selection.SelectionAction.ClearAndEnableSpecific, _
                True, False, selectionMask, obj, cursor)

        If resp = Selection.Response.ObjectSelected Or _
          resp = Selection.Response.ObjectSelectedByName Then
            Return Selection.Response.Ok
        Else
            Return Selection.Response.Cancel
        End If

    End Function

End Module

